package tree

import (
	"math/big"
	"testing"

	"github.com/ethereum/go-ethereum/common"
	"github.com/ethereum/go-ethereum/crypto"
)

func TestMst(t *testing.T) {

	datas := [][]byte{}
	vals := []*big.Int{}
	for i := 1; i <= 7; i++ {
		datas = append(datas, crypto.Keccak256(big.NewInt(int64(i)).Bytes()))
		vals = append(vals, big.NewInt(int64(i)))
	}

	tree := NewMerkleSumTree(datas, vals)
	t.Log(tree.GetRoot())
	t.Log(tree.RootNode.Value.Hash, tree.RootNode.Value.BigValue)
	t.Log("---")
	for i := len(tree.Levels) - 1; i >= 0; i-- {
		t.Log(tree.Levels[i])
	}
	t.Log("---")
	subNode := tree.FindMerkleSumNode(common.HexToHash("0x8a28d124351a95140ed4fad3468a9833523faf12e07c24eac13e1c1d468adb95"))

	layers := MerkleSumTreeTraversal(subNode, 3)

	for _, layer := range layers {
		t.Log(layer)
	}

}
