package util

import (
	"bytes"

	"github.com/ethereum/go-ethereum/common"
)

type AddressSlice []common.Address

func (s AddressSlice) Len() int {
	return len(s)
}

func (s AddressSlice) Less(i, j int) bool {
	return bytes.Compare(s[i].Bytes(), s[j].Bytes()) < 0
}

func (s AddressSlice) Swap(i, j int) {
	s[i], s[j] = s[j], s[i]
}
